#!/usr/bin/perl
use strict;

use FindBin qw($Bin);
use File::Basename;

my $window_size = 500;
my $shift_length = 50;
my $nwindowsintarget = 10000;

my $pos_fa    = $ARGV[0]; #testdata/pos.fa
my $neg_fa    = $ARGV[1]; #testdata/neg.fa
my $target_fa = $ARGV[2]; #testdata/target.fa
my $outdir    = $ARGV[3]; # outdir

if(!defined($pos_fa) || !defined($neg_fa) || !defined($target_fa) || !defined($outdir)){
	print STDERR "USAGE:\n./score.pl <pos.fa> <neg.fa> <target.fa> <outdir>\nPlease check README file for more information.\n";
	exit;
}

mkdir($outdir);

my $pos_name = basename($pos_fa);
my $neg_name = basename($neg_fa);
my $target_name = basename($target_fa);
print STDERR "Processing positive file\n";
system("$Bin/src/kworddistr.pl -rc 1 $pos_fa 6 > $outdir/$pos_name.6.txt");
system("$Bin/src/combine_counts.pl $outdir/$pos_name.6.txt $outdir/pos.6.txt");
print STDERR "Processing negative file\n";
system("$Bin/src/kworddistr.pl -rc 1 $neg_fa 6 > $outdir/$neg_name.6.txt");
system("$Bin/src/combine_counts.pl $outdir/$neg_name.6.txt $outdir/neg.6.txt");
print STDERR "Processing target file\n";
system("$Bin/src/preproc_target.pl -rc 1 $target_fa $outdir $window_size $shift_length > $outdir/$target_name.6.txt");
system("$Bin/src/compare_hex $outdir/pos.6.txt $outdir/neg.6.txt $outdir/$target_name.6.txt $nwindowsintarget $shift_length > $outdir/score.HexMCD");
print STDERR "Score file is located at: outdir/score.HexMCD\n";
